function p = isprimitive (poly)
  ## Fast return since primitive polynomial can't be even
  if (rem(poly, 2) == 0)
    p = false;
  else

    m = 1;
    while (poly > 2 .^ (m +1))
      m++;
    endwhile
    n = 2 .^ m - 1;
    repr = zeros(1, 2 .^ m);
    mask = 1;

    repr(1) = 1;
    for i = 1 : n
      repr (mask + 1) = 1;
      mask *= 2;
      if (mask >= 2.^m)
	mask = bitxor (mask, poly);
      endif
    endfor

    if (mask != 1)
      p = false;
    else
      p = true;
      for i = 1 : n + 1
	if (!repr(i))
	  p = false;
	  break;
	endif
      endfor
    endif
  endif
endfunction
