function b = subsref (a, s)
  switch s.type
    case "()"
      ind = s.subs{:};
      b = gf (a.x(ind), a.m, a.prim_poly)
    case "{}"
      error ("galois field can not be indexed with {}");
    case "."
      fld = s.subs;
      if (strcmp (fld, "x"))
	b = a.x;
      elseif (strcmp (fld, "m"))
	b = a.m;
      elseif (strcmp (fld, "n"))
	b = a.n;
      elseif (strcmp (fld, "prim_poly"))
	b = a.prim_poly;
      elseif (strcmp (fld, "index_of"))
	b = a.index_of;
      elseif (strcmp (fld, "alpha_to"))
	b = a.alpha_to;
      else
	error ("subsref: unrecognized value in galois field");
      endif
  endswitch
endfunction
